<template>
  <div class="app-container">
    <div class="filter-container" style="padding-bottom:0;">
      <router-link to="/goods/category/create"><el-button class="filter-item" type="primary" icon="el-icon-circle-plus-outline">添加分类</el-button></router-link>
      <el-button class="filter-item" type="primary" icon="el-icon-sort" @click="batchSaveSort">批量更新排序</el-button>
    </div>
    <div class="filter-title">
      <p>商品分类的排序值是指本页面和小程序首页分类的排列顺序，数值越小排序越靠前，排序值允许重复。</p>
    </div>
    <el-table
      v-loading="listLoading"
      :data="list"
      element-loading-text="Loading"
      border
      fit
      highlight-current-row
      :header-cell-style="{background:'#eef1f6',color:'#606266'}"
    >
      <el-table-column align="center" label="序号" width="50px">
        <template slot-scope="scope">
          {{ scope.$index+1 }}
        </template>
      </el-table-column>
      <el-table-column label="分类名称" align="center" prop="classifyName" />
      <el-table-column label="分类图标" align="center" prop="classifyImage">
        <template slot-scope="{row}">
          <img :src="row.classifyImage" alt="" width="50">
        </template>
      </el-table-column>
      <el-table-column label="排序值" align="center" prop="sort">
        <template slot-scope="{row}">
          <el-input-number v-model="row.sort" controls-position="right" :min="1" :max="999" :maxlength="3" size="mini" style="width:65px;" />
        </template>
      </el-table-column>
      <el-table-column class-name="status-col" label="状态" align="center" prop="status">
        <template slot-scope="{row}">
          <el-tooltip :content="row.status*1 === 1 ? '停用' : '启用'" placement="top">
            <el-switch
              v-model="row.status"
              active-value="1"
              inactive-value="0"
              @change="changeStatus(row.id, row.status)"
            />
          </el-tooltip>
        </template>
      </el-table-column>
      <el-table-column align="center" label="添加时间" prop="addTime">
        <template slot-scope="{row}">
          <span>{{ row.addTime | parseTime('{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <router-link :to="'/goods/category/edit/' + row.id "><el-button type="primary" size="mini" style="width: 80px;">编辑</el-button></router-link>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>20" :total="total" :page.sync="listQuery.index" :limit.sync="listQuery.pageSize" @pagination="getList" />

  </div>
</template>

<script>
import { getCategory, switchClassify, saveCategorySort } from '@/api/goods-classify'
import Pagination from '@/components/Pagination'

export default {
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        1: 'success',
        0: 'danger'
      }
      return statusMap[status]
    }
  },
  data() {
    return {
      list: null,
      listLoading: true,
      total: 0,
      listQuery: {
        index: 1,
        pageSize: 20,
        organizeId: this.$store.getters.organizeId
      }
    }
  },
  computed: {
    organizeId() {
      return this.$store.getters.organizeId
    }
  },
  created() {
    this.getList()
  },
  methods: {
    getList() {
      this.listLoading = true
      getCategory(this.listQuery).then(response => {
        this.list = response.data.results
        this.total = response.data.totalRecord
        this.listLoading = false
      })
    },
    changeStatus(id, status) {
      const confirmTxt = '确定要' + (status * 1 === 1 ? '启用' : '停用') + '该分类吗？'
      this.$confirm(confirmTxt).then(_ => {
        this.confirmChange(id)
      }).catch(() => {
        this.getList()
      })
    },
    confirmChange(id) {
      switchClassify({ id: id }).then(() => {
        this.getList()
      }).catch(() => {
        this.getList()
      })
    },
    batchSaveSort() {
      const sorts = []
      this.list.map(item => {
        if (item.sort) {
          sorts.push(item.id + '-' + Math.abs(item.sort))
        }
      })
      saveCategorySort({ newProducSorttList: sorts.join(',') }).then(response => {
        this.$message({ message: response.msg, type: 'success', center: true })
        this.getList()
      }).catch(() => {
        this.getList()
      })
    }
  }
}

</script>
<style>
.el-input-number.is-controls-right .el-input__inner {
    padding-left: 5px;
    padding-right: 30px;
}
</style>
<style lang="scss" scoped>
.filter-title{
  float: left;
  font-size: 12px;
  line-height: 18px;
  text-align: left;
  color: #2E3748;
}
.filter-title p{
  margin:10px 0;
}
</style>
